## libav 9.11

=== libswscale/x86/Makefile ===
OBJS-$(CONFIG_XMM_CLOBBER_TEST) += x86/w64xmmtest.o

MMX-OBJS                        += x86/rgb2rgb.o                        \
                                   x86/swscale.o                        \
                                   x86/yuv2rgb.o                        \

YASM-OBJS                       += x86/input.o                          \
                                   x86/output.o                         \
                                   x86/scale.o                          \

=== debian/changelog ===
libav (6:9.11-2ubuntu2) trusty; urgency=medium

  * No-change rebuild for x264 soname bump.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Mar 2014 05:55:46 +0000

libav (6:9.11-2ubuntu1) trusty; urgency=low

  * Merge from unstable, remaining changes:
    - build-depend on libtiff5-dev rather than libtiff4-dev,
      avoids FTBFS caused by imlib
  * This version of libav supports Opus in Ogg (LP: #1265196)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 02 Mar 2014 14:57:25 -0500

libav (6:9.11-2) unstable; urgency=low

  * Avoid the use of pipes to not cover segfaulting libavcodecs (cf. #726733)
  * refactor call_and_install_avconv_dump functionality
  * Rebuild against libfreetype 2.5.1 (closes: #731307)
  * i386 shared builds must be optimized for 586, (closes: 728928, #688384)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 22 Feb 2014 14:34:54 +0000

libav (6:9.11-1) unstable; urgency=low

  * Imported Upstream version 9.11
    - drop patch mathematics-remove-asserts-from-av_rescale_rnd.patch,
      merged upstream
    - mathematics: remove asserts from av_rescale_rnd, (Closes: #718805)
  * Support Opus in Ogg containers (Closes: #733884, 720563)
  * Refactor conffile moving
  * No longer build-depend on libtiff4-dev. Closes: #736020
  * Disable opencv filter because of #737584
  * Check upstream OpenPGP signatures (Closes: #723692)

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 05 Feb 2014 00:24:42 +0000

libav (6:9.10-3) unstable; urgency=low

  * Add upstream patch: mathematics: remove asserts from av_rescale_rnd
    Closes: #718805
  * Remove the makeinfo patch, it just disables generation of the html
    equivalents of the manpages
  * No longer build-depend on libtiff4-dev. Closes: #736020
  
 -- Reinhard Tartler <siretart@tauware.de>  Wed, 22 Jan 2014 08:13:40 -0500

libav (6:9.10-2) unstable; urgency=low

  [ Fabian Greffrath ]
  * Fix upstream changelog link in previous changelog entry.
  * Transition from the "texi2html" utility to the "makeinfo" utility from the
    texinfo package, fixes build-depends-on-obsolete-package lintian error and
    addresses <https://lists.debian.org/debian-devel/2013/05/msg01516.html>.
  * debhelper (>= 9) is now available in stable and old-bpo.
  * Use "set -e" in the body of the libav-tools maintainer scripts.
  * Fix vcs-field-not-canonical lintian warning.
  * Set executable permissions for qt-faststart, fixes unstripped-binary-or-object
    lintian warning.
  * Fix some spelling errors detected by lintian.

  [ Reinhard Tartler ]
  * compile against libtiff5-dev
  * Drop some special code paths for building the ubuntu flavor
    (no longer necessary over there)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 03 Nov 2013 08:35:04 -0500

libav (6:9.10-1ubuntu7) trusty; urgency=medium

  * Drop build-deps arch restriction for libav, bootstrap complete.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 20:00:22 +0000

libav (6:9.10-1ubuntu6) trusty; urgency=medium

  * Disable altivec optimization for all build flavours on ppc64*.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 14:47:28 +0000

libav (6:9.10-1ubuntu5) trusty; urgency=medium

  * Build altivec flavor on powerpc only. 

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 09:47:10 +0000

libav (6:9.10-1ubuntu4) trusty; urgency=medium

  * Add altivec flavor build for ppc64,ppc64el.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 09:37:09 +0000

libav (6:9.10-1ubuntu3) trusty; urgency=medium

  * Specify --enable-pic for ppc64, ppc64el.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 09:22:44 +0000

libav (6:9.10-1ubuntu2) trusty; urgency=medium

  * Bootstrap libav on ppc64el.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 03:45:49 +0000

libav (6:9.10-1ubuntu1) trusty; urgency=low

  * Build all -extra flavors from this source package, as libav got demoted
    from main to universe, cf LP: #1243235
  * Simplify debian/rules to follow exactly the code that debian executes
  * New upstream (LP: #1180288) fixes lots of security issues (LP: #1242802)
  * Merge from unstable, remaining changes:
    - build-depend on libtiff5-dev rather than libtiff4-dev,
      avoids FTBFS caused by imlib
    - follow the regular debian codepaths

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 22 Oct 2013 23:24:08 -0400

libav (6:9.10-1) unstable; urgency=medium

  * New upstream release 9.10
  * Too many security related upstream changes to list here, please cf. to
    upstream changelog:
    http://git.libav.org/?p=libav.git;a=blob;f=Changelog;hb=refs/tags/v9.10
  * Urgency set to medium because new upstream release fixes many security
    issues.
  * Do not accidentally overwrite installed binaries from different flavors.
    Thanks to Fabian Greffrath for the patch (Closes: #725956)

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 10 Oct 2013 10:53:54 -0400

libav (6:9.9-1) experimental; urgency=low

  * New upstream release 9.9
  * Too many security related upstream changes to list here, please cf. to
    upstream changelog. Closes: #717009

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 07 Oct 2013 18:07:14 -0400

libav (6:9.8-2) unstable; urgency=low

  * Upload to unstable
  * Weaken dependencies on libx264, opencv and frei0r for now to allow
    compilation. This dependency will be tightened as soon as the
    libraries have been updated in unstable.

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 13 Aug 2013 15:10:05 +0200

libav (6:9.8-1) experimental; urgency=low

  * New upstream release 9.8, Closes: #716734, #716735
  * Upstream Changes:
  
     - kmvc: Clip pixel position to valid range
     - kmvc: Use fixed sized arrays in the context
     - indeo: Reject negative array indexes
     - indeo: Check for reference when inheriting motion vectors
     - indeo: Properly forward the error codes
     - mjpeg: Check the unescaped size for overflows


=== debian/control ===
Source: libav
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Sam Hocevar (Debian packages) <sam+deb@zoy.org>,
 Loïc Minier <lool@debian.org>,
 Reinhard Tartler <siretart@tauware.de>,
 Fabian Greffrath <fabian+debian@greffrath.com>,
 Andres Mejia <amejia@debian.org>,
 Jonas Smedegaard <dr@jones.dk>
Standards-Version: 3.9.4
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/libav.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/libav.git;a=summary
Homepage: http://libav.org/
Build-Depends-Indep:
 doxygen
Build-Depends:
 debhelper (>= 9),
 frei0r-plugins-dev,
 libasound2-dev [linux-any],
 libbz2-dev,
 libcdio-cdda-dev,
 libcdio-dev,
 libcdio-paranoia-dev,
 libdc1394-22-dev [linux-any],
 libfreetype6-dev (>= 2.5.1),
 libgnutls-dev,
 libgsm1-dev,
 libjack-dev,
 libmp3lame-dev,
 libopencore-amrnb-dev,
 libopencore-amrwb-dev,
 libopenjpeg-dev,
 libopus-dev (>= 1.0.1),
 libpulse-dev,
 libraw1394-dev [linux-any],
 librtmp-dev (>= 2.2e-4),
 libschroedinger-dev,
 libsdl1.2-dev,
 libspeex-dev,
 libtheora-dev (>> 0.0.0.alpha4),
 libtiff5-dev | libtiff-dev,
 libva-dev [!hurd-any],
 libvdpau-dev,
 libvo-aacenc-dev,
 libvo-amrwbenc-dev,
 libvorbis-dev,
 libvpx-dev,
 libx11-dev,
 libx264-dev,
 libxext-dev,
 libxfixes-dev,
 libxvidcore-dev,
 libxvmc-dev,
 texi2html,
 yasm [any-amd64 any-i386],
 zlib1g-dev

Package: libav-tools
Section: video
Architecture: any
Replaces:
 libavcodec-extra-53 (<< 4:0.6~)
Pre-Depends:
 ${misc:Pre-Depends},
 dpkg (>= 1.15.7.2~)
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 frei0r-plugins (>= 1.3)
Conflicts:
 ffprobe
Description: Multimedia player, server, encoder and transcoder
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This package contains the avplay multimedia player, the avserver
 streaming server, the avconv audio and video encoder, and the avprobe
 stream analyzer.  They support most existing file formats (AVI, MPEG,
 OGG, Matroska, ASF...) and encoding formats (MPEG, DivX, MPEG4, AC3,
 DV...). Additionally, it contains the qt-faststart utility which
 rearranges Quicktime files to facilitate network streaming.
 .
 This package also serves as a replacement for the former 'ffmpeg'
 package.

Package: libav-dbg
Section: debug
Priority: extra
Architecture: any
Replaces:
 ffmpeg-dbg (<< 6:0.8.3-5),
 libav-extra-dbg (<< 6:0.8.3-5)
Breaks:
 ffmpeg-dbg (<< 6:0.8.3-5),
 libav-extra-dbg (<< 6:0.8.3-5)
Depends:
 libav-tools (= ${binary:Version}),
 libavcodec54 (= ${binary:Version}) | libavcodec-extra-54 (= ${binary:Version}),
 libavdevice53 (= ${binary:Version}),
 libavformat54 (= ${binary:Version}),
 libavutil52 (= ${binary:Version}),
 libswscale2 (= ${binary:Version}),
 ${misc:Depends}
Description: Debug symbols for Libav related packages
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This package contains debug data of the Libav related shared libraries.
 .
 Most people will not need this package. Please install it to produce useful
 stacktraces to help debugging the Libav library.

Package: libav-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Description: Documentation of the Libav API
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This package contains the html doxygen documentation of the Libav API.
 .
 Only application developers will find this package useful.

Package: libavutil52
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Libav utility library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the common utility library from Libav. It contains shared code
 used by all other Libav libraries.

Package: libavcodec54
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 libavcodec-extra-54
Replaces:
 libavcodec-extra-54
Breaks:
 mplayer (<< 2:1.0~rc4.dfsg1+svn34540-1~)
Description: Libav codec library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the codec library from Libav (both encoding and decoding).
 .
 It supports most existing codecs (MPEG, MPEG2, MPEG4, AC3, DV...).

Package: libavdevice53
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 libavdevice-extra-53
Breaks:
 libavdevice-extra-53 (<< 5:0.8.1-2)
Description: Libav device handling library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the device handling library from Libav.

Package: libavformat54
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 libavformat-extra-54
Breaks:
 libavformat-extra-54 (<< 5:0.8.1-2)
Description: Libav file format library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the library for handling file formats from Libav.
 .
 It supports most existing file formats (AVI, MPEG, OGG, Matroska,
 ASF...).

Package: libavfilter3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 frei0r-plugins (>= 1.3)
Replaces:
 libavfilter-extra-3
Breaks:
 libavfilter-extra-3 (<< 5:0.8.1-2)
Description: Libav video filtering library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video filtering library from Libav.

Package: libswscale2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 libswscale-extra-2
Breaks:
 libswscale-extra-2 (<< 5:0.8.1-2)
Description: Libav video scaling library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video software scaling library from Libav.

Package: libavutil-dev
Section: libdevel
Architecture: any
Depends:
 libavutil52 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavutil
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the common utility library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavutil.

Package: libavcodec-dev
Section: libdevel
Architecture: any
Depends:
 libavcodec54 (<= ${source:Upstream-Version}-99) | libavcodec-extra-54 (<= ${source:Upstream-Version}-99),
 libavcodec54 (>= ${binary:Version}) | libavcodec-extra-54 (>= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 libdc1394-22-dev [linux-any],
 libgsm1-dev,
 libogg-dev,
 libraw1394-dev [linux-any],
 libschroedinger-dev,
 libspeex-dev,
 libtheora-dev (>> 0.0.0.alpha4),
 libvorbis-dev,
 libx11-dev,
 libxext-dev,
 zlib1g-dev
Description: Development files for libavcodec
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the codec library from Libav. It supports most existing
 encoding formats (MPEG, DivX, MPEG4, AC3, DV...).
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavcodec.

Package: libavdevice-dev
Section: libdevel
Architecture: any
Depends:
 libavdevice53 (= ${binary:Version}),
 libavformat-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavdevice
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the device handling library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavdevice.

Package: libavformat-dev
Section: libdevel
Architecture: any
Depends:
 libavcodec-dev (= ${binary:Version}),
 libavformat54 (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavformat
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the demuxer library from Libav. It supports most
 existing file formats (AVI, MPEG, OGG, Matroska, ASF...).
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavformat.

Package: libavfilter-dev
Section: libdevel
Architecture: any
Depends:
 libavcodec-dev (= ${binary:Version}),
 libavfilter3 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavfilter
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video filtering library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavfilter.

Package: libswscale-dev
Section: libdevel
Architecture: any
Depends:
 libavutil-dev (= ${binary:Version}),
 libswscale2 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libswscale
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video scaling library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libswscale.

Package: libavresample-dev
Section: libdevel
Architecture: any
Depends:
 libavutil-dev (= ${binary:Version}),
 libavresample1 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavresample
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video scaling library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libswrescale.

Package: libavresample1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Replaces:
 libavresample0
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Libav audo resampling library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the audio software resampling library from Libav.

Package: libavutil-extra-52
Section: oldlibs
Priority: extra
Architecture: all
Depends:
 libavutil52,
 ${misc:Depends},
Description: Libav utility library (transitional package)
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This package is only used for transitional purposes and can be safely
 removed when no other packages depend on this package.

Package: libavcodec-extra-54
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 libavcodec54
Conflicts:
 libavcodec54
Breaks:
 mplayer (<< 2:1.0~rc4.dfsg1+svn34540-1~)
Description: Libav codec library (additional codecs)
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the codec library from Libav (both encoding and decoding).
 .
 This package is a replacement for the regular libavcodec54 library package;
 it contains the following additional codecs:
 .
  * OpenCORE Adaptive Multi-Rate (AMR) Narrow-Band (Encoder/Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Wide-Band (Decoder)

=== debian/rules ===
#!/usr/bin/make -f

EPOCH=6:
DEB_SOURCE := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
DEB_VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
UPSTREAM_VERSION := $(shell echo $(DEB_VERSION) | sed -r 's/[^:]+://; s/-[^-]+$$//')
SHLIBS_VERSION := $(EPOCH)9.1-1

# these package do not build -extra variants
LIB_PKGS := $(shell sed -nr 's/^Package:[[:space:]]*(lib(avutil|avdevice|avformat|avfilter|avresample|swscale)[0-9]+)[[:space:]]*$$/\1/p' debian/control)
# these packages do build -extra variants
LIB_PKGS2 := $(shell sed -nr 's/^Package:[[:space:]]*(libavcodec[0-9]+)[[:space:]]*$$/\1/p' debian/control)
# these packages are the -extra- variants
LIB_EXTRA_PKGS := $(shell sed -nr 's/^Package:[[:space:]]*(libavcodec-extra-[0-9]+)[[:space:]]*$$/\1/p' debian/control)

# these are the -dev packages
DEV_PKGS := $(shell echo $(LIB_PKGS) $(LIB_PKGS2) | sed 's/[0-9]\+\>/-dev/g')

# Support multiple makes at once
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
# on i386 and amd64, we query the system unless overriden by DEB_BUILD_OPTIONS
ifeq      ($(DEB_HOST_ARCH),i386)
NUMJOBS := -j$(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
else ifeq ($(DEB_HOST_ARCH),amd64)
NUMJOBS := -j$(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
endif
endif

include debian/confflags
OPT_FLAVORS := $(filter-out static shared, $(FLAVORS))

info:
	@echo Packages that do not build -extra variants: $(LIB_PKGS)
	@echo Packages that do build -extra variatnts: $(LIB_PKGS2)
	@echo Packages that are the -extra- variants: $(LIB_EXTRA_PKGS)

$(info FLAVORS = $(FLAVORS))
$(info DEB_BUILD_OPTIONS = $(DEB_BUILD_OPTIONS))
$(info CFLAGS = $(CFLAGS))
$(info CPPFLAGS = $(CPPFLAGS))
$(info LDFLAGS = $(LDFLAGS))

define dh_install_file_opt_flavor
	  grep @DEB_HOST_MULTIARCH_OPT@ < $(1).in | \
	  sed 's:@DEB_HOST_MULTIARCH_OPT@:$(DEB_HOST_MULTIARCH)/$($(2)_shlibdir):g' >> $(1)

endef

DH_INSTALL_FILES := $(foreach pkg, $(LIB_PKGS) $(LIB_PKGS2) $(LIB_EXTRA_PKGS) $(DEV_PKGS), debian/$(pkg).install)
$(DH_INSTALL_FILES):
	sed 's/@DEB_HOST_MULTIARCH\(_OPT\)\?@/$(DEB_HOST_MULTIARCH)/g' $@.in > $@
	$(foreach opt_flavor,$(OPT_FLAVORS),$(call dh_install_file_opt_flavor,$@,$(opt_flavor)))

configure-%: configure-stamp-%
configure-stamp-%: configure
	dh_testdir
	mkdir -p debian-$*
	cd debian-$* && CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" $(CURDIR)/configure \
		$($*_build_confflags) $(extra_$*_build_confflags)
	touch $@
configure-extra-stamp-%:
	dh_testdir
	mkdir -p debian-extra-$*
	cd debian-extra-$* && CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" $(CURDIR)/configure \
		$($*_build_confflags) $(v3_confflags) $(extra_$*_build_confflags)
	touch $@

build-%: build-stamp-%
build-stamp-%: configure-stamp-%
	dh_testdir
	$(MAKE) -C debian-$* $(NUMJOBS) V=1
	touch $@
build-extra-stamp-%: configure-extra-stamp-%
	dh_testdir
	$(MAKE) -C debian-extra-$* $(NUMJOBS) V=1
	touch $@

debian-shared/tools/qt-faststart: build-stamp-shared
	$(MAKE) -C debian-shared tools/qt-faststart V=1

build: build-stamp build-extra
build-stamp: $(addprefix build-stamp-, $(FLAVORS)) debian-shared/tools/qt-faststart
	touch $@
build-extra: $(addprefix build-extra-stamp-, $(filter-out static,$(FLAVORS)))
	touch $@

clean:
	dh_testdir
	rm -f build-stamp build-extra $(addprefix build-stamp-, $(FLAVORS)) \
	    $(addprefix build-extra-stamp-, $(FLAVORS)) \
	    $(addprefix configure-stamp-, $(FLAVORS)) \
	    $(addprefix configure-extra-stamp-, $(FLAVORS)) \
	    build-doxy-stamp
	rm -rf libav/ # created by the libav-extra variant
	rm -rf $(addprefix debian-, $(FLAVORS)) \
		$(addprefix debian-extra-, $(FLAVORS)) doxy
	dh_clean $(DH_INSTALL_FILES) $(wildcard formats*.txt) $(wildcard codecs*.txt)

# The trailing newline is important!
define install_flavor
	$(MAKE) -C debian-$(1) install DESTDIR=$(CURDIR)/debian/tmp \
	    mandir=$(CURDIR)/debian/tmp/usr/share/man

endef

# The trailing newline is important!
define install_flavor_extra
	$(MAKE) -C debian-extra-$(1) install DESTDIR=$(CURDIR)/debian/tmp/extra \
	    mandir=$(CURDIR)/debian/tmp/usr/share/man

endef

# usage $(call call_and_install_avconv_dump,$package,$parameter), paramter like "codecs" or "formats"
define call_and_install_avconv_dump
	mkdir -p debian/$(1)/usr/share/doc/$(1)
	env LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)" \
	debian/tmp/usr/bin/avconv -$(2) > debian/$(1)/usr/share/doc/$(1)/$(2)-$(DEB_HOST_ARCH).txt
	cat debian/$(1)/usr/share/doc/$(1)/$(2)-$(DEB_HOST_ARCH).txt

endef

# installs arch-dependent files only
install: install-common install-extra
install-common: build $(DH_INSTALL_FILES)
	dh_testdir
	dh_testroot
	dh_prep -a
	$(foreach flavor,$(FLAVORS),$(call install_flavor,$(flavor)))
	mkdir -p debian/tmp/etc
	install -m 644 -D doc/avserver.conf debian/tmp/etc/
	install -m 755 -D debian-shared/tools/qt-faststart debian/tmp/usr/bin/qt-faststart
	dh_install $(addprefix -N,$(LIB_EXTRA_PKGS)) \
		 --fail-missing --sourcedir=debian/tmp
	$(call call_and_install_avconv_dump,libavformat54,formats)
	$(call call_and_install_avconv_dump,libavcodec54,codecs)
install-extra: build $(DH_INSTALL_FILES)
	dh_testdir
	dh_testroot
	$(foreach flavor,$(filter-out static,$(FLAVORS)),$(call install_flavor_extra,$(flavor)))
	dh_install $(addprefix -p,$(LIB_EXTRA_PKGS)) --fail-missing \
		--sourcedir=debian/tmp/extra
	$(call call_and_install_avconv_dump,libavcodec-extra-54,codecs)
ifeq ($(DEB_SOURCE), libav)
	dh_installdocs -a doc/APIchanges
	install -m 644 -D debian-shared/doc/*.html doc/t2h.init debian/libav-tools/usr/share/doc/libav-tools
	dh_installexamples -p libavcodec-dev libavcodec/api-example.c
	dh_installchangelogs -a Changelog
else
	dh_installchangelogs -a libav/Changelog
endif

binary-indep:
	dh_testdir
	dh_testroot
	dh_prep -i
	doxygen doc/Doxyfile
	mkdir -p debian/libav-doc/usr/share/doc/libav-doc
	mv -v doc/doxy/html debian/libav-doc/usr/share/doc/libav-doc
	dh_installdocs -i
	dh_installchangelogs -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i -- -Zxz

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installman -plibav-tools debian/qt-faststart.1
	dh_strip -a --dbg-package=libav-dbg
	dh_lintian -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a

	# operate on non -extra package producing packages
	for pkg in $(LIB_PKGS); do \
	    dh_makeshlibs -p"$$pkg" -V"$$pkg (>= $(SHLIBS_VERSION))"; \
	done
	# operate e.g. the -extra- packages, produce shlibs that have alternative dependencies
	for pkg in $(LIB_EXTRA_PKGS); do \
	    npkg=$$(echo "$$pkg" | sed -r 's/-extra-//'); \
	    dh_makeshlibs -p"$$pkg" -V"$$npkg (>= $(SHLIBS_VERSION)) | $$pkg (>= $(EPOCH)$(UPSTREAM_VERSION))"; \
	done
	# operate on packages with -extra- variants such as libavcodec54 - produce shlibs that have alternative dependencies
	for pkg in $(LIB_PKGS2); do \
	    upkg=$$(echo "$$pkg" | sed -r 's/([0-9]+)$$/-extra-\1/'); \
	    dh_makeshlibs -p"$$pkg" -V"$$pkg (>= $(SHLIBS_VERSION)) | $$upkg (>= $(EPOCH)$(UPSTREAM_VERSION))"; \
	done
	dh_shlibdeps
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a -- -Zxz

binary: binary-indep binary-arch

.PHONY: build $(addprefix build-, $(FLAVORS)) \
	clean \
	configure $(addprefix configure-, $(FLAVORS)) \
	binary binary-indep binary-arch \
	install install-common install-extra \
	get-orig-source
